' BASIC '/
type TQuantumLogical
end type

type TDendrite extends object
    declare sub Receive
end type

type TAxon extends object
    declare sub Transmite
end type

type TNeuron extends object
    as TDendrite Denditres(5)
    as TAxon Axon
end type

type TBrain extends object
    as TNeuron Neurons(Any)
end type


/' BASIC PARAMETERS '/
type TColor extends object
end type

type TTactil extends object
end type

type TSmell extends object
end type

enum TShape
    spUnknown,spRect,spEllipse,spPolygon
end enum

type TImage extends object
    as TShape shape
end type

/' MEMORIES '/
type TMemItem
    as TColor color
    as TSmell smell
    as TTactil Tactil
    as TImage image
end type

type TMemory extends object
    as TMemItem items(any)
end type

type TTempMemory extends TMemory
    declare function CompareItem() as integer
end type

type TLongMemory extends TMemory
end type

/' implementation '/
dim shared as TBrain ia
